﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NejvetsiZe3CiselWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        /// <summary>
        /// Statická třída obsahující deklaraci textové konstanty
        /// </summary>
        static class Constants
        {
            public const string ZadCislo = "Zadejte číslo";
        }
        public MainWindow()
        {
            InitializeComponent();
            TxtA.Text = Constants.ZadCislo;
            TxtB.Text = Constants.ZadCislo;
            TxtC.Text = Constants.ZadCislo;

        }

        // vymazání počáteční textu při vstupu do textboxu
        private void TxtA_GotFocus(object sender, RoutedEventArgs e)
        {
            if (TxtA.Text == Constants.ZadCislo)
            {
                TxtA.Text = string.Empty;
            }
        }

        private void TxtB_GotFocus(object sender, RoutedEventArgs e)
        {
            if (TxtB.Text == Constants.ZadCislo)
            {
                TxtB.Text = string.Empty;
            }
        }

        private void TxtC_GotFocus(object sender, RoutedEventArgs e)
        {
            if (TxtC.Text == Constants.ZadCislo)
            {
                TxtC.Text = string.Empty;
            }
        }

        // vyplnění počátečního textu při opuštění prázdného objektu
        private void TxtA_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((TxtA.Text == string.Empty) || (int.TryParse(TxtA.Text, out _) == false))
            {
                TxtA.Text = Constants.ZadCislo;
            }
        }

        private void TxtB_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((TxtB.Text == string.Empty) || (int.TryParse(TxtB.Text, out _) == false))
            {
                TxtB.Text = Constants.ZadCislo;
            }
        }

        private void TxtC_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((TxtC.Text == string.Empty) || (int.TryParse(TxtC.Text, out _) == false))
            {
                TxtC.Text = Constants.ZadCislo;
            }
        }

        private void BtnKonec_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        // Metoda bez návratu pro porovnání 3 čísel - vnořené rozhodování
        private void BtnPorovnej1_Click(object sender, RoutedEventArgs e)
        {
            int a, b, c;

            int.TryParse(TxtA.Text, out  a);
            int.TryParse(TxtB.Text, out  b);
            int.TryParse(TxtC.Text, out  c);

            if (a > b)
            {
                if (a > c)
                {
                    MessageBox.Show("Největší je a = " + a);
                }
                else
                {
                    if (a == c)
                    {
                        MessageBox.Show("Největší je a = c = " + a);
                    }
                    else
                        MessageBox.Show("Největší je c = " + c);
                }
            }
            else
            {
                if (a == b)
                {
                    if (b > c)
                    {
                        MessageBox.Show("Největší číslo je a = b = " + a);
                    }
                    else
                        if (b == c)
                    {
                        MessageBox.Show("Nejbětší je a = b = c " + a);
                    }
                    else
                        MessageBox.Show("Největší je c = " + c);

                }
                else
                {
                    if (b > c)
                    {
                        MessageBox.Show("Největší je b = " + b);
                    }
                    else
                        if (b == c)
                    {
                        MessageBox.Show("Největší je b = c = " + b);
                    }
                    else
                        MessageBox.Show("Největší je c = " + c);
                }
            }

        }

        /// <summary>
        /// metoda s celočíselným návratem většího čísla ze dvou zadaných
        /// </summary>
        /// <param name="x"> první celé číslo</param>
        /// <param name="y">druhé celé číslo</param>
        /// <returns>maximum ze dvou čísel</returns>
        private int VetsiRovno(int x, int y)
        {
            if (x >= y)
            {
                return x;
            }
            else
                return y;

            // x >= y ? x : y

        }

        private void BtnPorovnej3_Click(object sender, RoutedEventArgs e)
        {
            int max;
            int a, b, c;
            string s = "Největší je ";

            int.TryParse(TxtA.Text, out a);
            int.TryParse(TxtB.Text, out b);
            int.TryParse(TxtC.Text, out c);

            max = VetsiRovno(VetsiRovno(a, b), c);

            if (a == max)
            {
                s += "a = ";
            }
            if (b == max)
            {
                s += "b = ";
            }
            if (c == max)
            {
                s += "c = ";
            }
            MessageBox.Show(s + max);
        }
    }
}
